"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getTypedParams = void 0;
var format_message_parse_1 = __importDefault(require("format-message-parse"));
var isPlural = function (format) {
    return format === 'plural' || format === 'selectordinal';
};
var isSelect = function (format) {
    return format === 'select';
};
var hasHashtagOnly = function (element) {
    return element.length === 1 && element[0] === '#';
};
var isStringOnly = function (element) {
    return typeof element === 'string';
};
var isValidSubMessages = function (subMessages) {
    return typeof subMessages === 'object';
};
var getSubMessages = function (element, format) {
    if (element) {
        var subMessages = void 0;
        if (isPlural(format)) {
            subMessages = element[3];
        }
        else if (isSelect(format)) {
            subMessages = element[2];
        }
        if (isValidSubMessages(subMessages)) {
            return subMessages;
        }
    }
    return undefined;
};
var stackWithSubMessages = function (stack, subMessages) {
    // eslint-disable-next-line prefer-spread
    return stack.concat.apply(stack, Object.values(subMessages));
};
var getParamsFromPatternAst = function (parsedArray) {
    if (!parsedArray || !parsedArray.slice)
        return [];
    var stack = parsedArray.slice();
    var params = [];
    var used = new Set();
    while (stack.length) {
        var element = stack.pop();
        if (isStringOnly(element))
            continue;
        if (hasHashtagOnly(element))
            continue;
        var _a = __read(element, 2), name_1 = _a[0], format = _a[1];
        if (!used.has(name_1)) {
            params.push({ name: name_1 });
            used.add(name_1);
        }
        var subMessages = getSubMessages(element, format);
        if (subMessages) {
            stack = stackWithSubMessages(stack, subMessages);
        }
    }
    return params.reverse();
};
var getTypedParams = function (text) {
    try {
        return getParamsFromPatternAst((0, format_message_parse_1.default)(text));
    }
    catch (e) {
        return [];
    }
};
exports.getTypedParams = getTypedParams;
